diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index f8bca816..9ff0a2e0 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -1,7 +1,9 @@
 require "fileutils"
+require "digest"
 require "json"
 require "securerandom"
 require "time"
+require "hive/secret_patterns"
 
 module Hive
   module Events
@@ -15,6 +17,9 @@ module Hive
       round_complete
       clean_exit_auto_committed
       claude_completion_fallback
+      auto_retry_failure_observed
+      auto_retry_decision
+      marker_recovery
     ].freeze
 
     STATUS_TAIL_LINES = 20
@@ -32,6 +37,8 @@ module Hive
     # Keeps the full JSON line well below the single-write append budget
     # so concurrent emitters cannot interleave bytes within a record.
     MAX_MESSAGE_BYTES = 1024
+    MAX_DETAILS_BYTES = 4096
+    MAX_RECORD_BYTES = 8192
     MESSAGE_TRUNCATION_SUFFIX = "…[truncated]".freeze
 
     EM_DASH = "—".freeze
@@ -46,7 +53,7 @@ module Hive
     # appenders via the inode lock; we cap message size (see
     # MAX_MESSAGE_BYTES) so the full line stays small and well-defined.
     # status.md is derived state and is rewritten with atomic rename.
-    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil)
+    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil, details: nil)
       event_type = event_type.to_sym
       unless EVENT_TYPES.include?(event_type)
         raise ArgumentError, "unknown event_type #{event_type.inspect}; valid: #{EVENT_TYPES.inspect}"
@@ -58,9 +65,17 @@ module Hive
         "stage" => stage.to_s,
         "agent" => agent.nil? ? nil : agent.to_s,
         "event_type" => event_type.to_s,
-        "message" => message.nil? ? nil : truncate_message(message.to_s)
+        "message" => message.nil? ? nil : truncate_message(message.to_s),
+        "details" => normalize_details(details)
       }
 
+      # Keep the single append bounded even when a caller supplied a deeply
+      # nested probe payload.  The retained sentinel is enough for a reader to
+      # know that the record was deliberately capped, not malformed.
+      if JSON.generate(record).bytesize > MAX_RECORD_BYTES
+        record["details"] = { "truncated" => true }
+      end
+
       FileUtils.mkdir_p(task_folder)
       events_path = File.join(task_folder, "events.jsonl")
       # syswrite issues a single write(2) so the JSON payload + trailing
@@ -88,6 +103,33 @@ module Hive
       "#{trimmed}#{MESSAGE_TRUNCATION_SUFFIX}"
     end
 
+    def normalize_details(value)
+      return nil if value.nil?
+
+      sanitized = redact_details(value)
+      encoded = JSON.generate(sanitized)
+      return sanitized if encoded.bytesize <= MAX_DETAILS_BYTES
+
+      { "truncated" => true, "fingerprint" => Digest::SHA256.hexdigest(encoded) }
+    rescue JSON::GeneratorError, TypeError
+      { "unserializable" => true }
+    end
+
+    def redact_details(value)
+      case value
+      when Hash
+        value.each_with_object({}) { |(key, inner), out| out[key.to_s] = redact_details(inner) }
+      when Array
+        value.map { |inner| redact_details(inner) }
+      when String
+        Hive::SecretPatterns.redact(value).gsub(/\b(?:Bearer|Basic)\s+\S+/i, "[REDACTED:authorization]")
+      when Numeric, TrueClass, FalseClass, NilClass
+        value
+      else
+        value.to_s
+      end
+    end
+
     def render_status!(task_folder, last_record)
       events_path = File.join(task_folder, "events.jsonl")
       events = read_recent_events(events_path, STATUS_TAIL_LINES)
diff --git a/lib/hive/marker_recovery.rb b/lib/hive/marker_recovery.rb
new file mode 100644
index 00000000..a7302ca4
--- /dev/null
+++ b/lib/hive/marker_recovery.rb
@@ -0,0 +1,31 @@
+require "hive/events"
+require "hive/git_ops"
+require "hive/lock"
+require "hive/markers"
+
+module Hive
+  # Shared atomic marker-clear + hive-state persistence primitive.  Manual
+  # recovery and daemon recovery use this exact mutation, while each caller
+  # retains authority over whether it is safe to invoke.
+  class MarkerRecovery
+    def initialize(events: Hive::Events, git_ops: Hive::GitOps)
+      @events = events
+      @git_ops = git_ops
+    end
+
+    def clear!(task:, expected_name:, match_attrs: {}, action:, details: nil)
+      cleared = Hive::Markers.clear_current(task.state_file, expected_name: expected_name, match_attrs: match_attrs)
+      return false unless cleared
+
+      @events.emit(task_folder: task.folder, slug: task.slug,
+                   stage: "#{task.stage_index}-#{task.stage_name}", event_type: :marker_recovery,
+                   message: action, details: details || { action: action, marker: expected_name.to_s })
+      Hive::Lock.with_commit_lock(task.hive_state_path) do
+        @git_ops.new(task.project_root).hive_commit(
+          stage_name: "#{task.stage_index}-#{task.stage_name}", slug: task.slug, action: action
+        )
+      end
+      true
+    end
+  end
+end
diff --git a/lib/hive/stages/execute.rb b/lib/hive/stages/execute.rb
index c3081b89..9b4969ca 100644
--- a/lib/hive/stages/execute.rb
+++ b/lib/hive/stages/execute.rb
@@ -11,6 +11,7 @@ require "hive/stages/base"
 require "hive/worktree"
 require "hive/git_ops"
 require "hive/markers"
+require "hive/daemon/recoverable_failure"
 
 module Hive
   module Stages
@@ -204,6 +205,14 @@ module Hive
       end
 
       def mark_implementer_failure(task, cfg, impl_result)
+        # The tmux wrapper has already stamped a closed, attributed
+        # claude_launch_failed marker.  Do not flatten it to the generic
+        # implementer_failed shape while unwinding through run_pass.
+        current = Hive::Markers.current(task.state_file)
+        if current.name == :error && current.attrs["reason"] == "claude_launch_failed"
+          return { commit: "claude_launch_failed", status: :error }
+        end
+
         if implementer_hit_limit?(impl_result)
           Hive::Markers.set(task.state_file, :error,
                             reason: "limits_reached",
@@ -213,10 +222,21 @@ module Hive
           return { commit: "limits_reached", status: :error }
         end
 
-        Hive::Markers.set(task.state_file, :error,
-                          reason: "implementer_failed",
-                          status: impl_result&.fetch(:status, nil),
-                          message: impl_result&.fetch(:error_message, nil))
+        message = impl_result&.fetch(:error_message, nil)
+        attrs = {
+          reason: "implementer_failed",
+          status: impl_result&.fetch(:status, nil),
+          message: message
+        }
+        if execute_agent_name(cfg) == "codex" && Hive::Daemon::RecoverableFailure.codex_auth_401_text?(message)
+          # Keep a self-describing, non-secret diagnosis on fresh markers.
+          # The original CLI output may contain an Authorization value, so the
+          # durable marker uses canonical evidence instead.
+          attrs[:provider] = "codex"
+          attrs[:diagnostic] = Hive::Daemon::RecoverableFailure::CODEX_AUTH_DIAGNOSTIC
+          attrs[:message] = Hive::Daemon::RecoverableFailure::CODEX_AUTH_MESSAGE
+        end
+        Hive::Markers.set(task.state_file, :error, attrs)
         { commit: "implementer_failed", status: :error }
       end
 
diff --git a/test/fixtures/fake-codex b/test/fixtures/fake-codex
index f39775ea..1ab8f292 100755
--- a/test/fixtures/fake-codex
+++ b/test/fixtures/fake-codex
@@ -25,6 +25,29 @@ if [[ "${1:-}" == "--version" ]]; then
   exit 0
 fi
 
+if [[ "${1:-}" == "login" && "${2:-}" == "status" ]]; then
+  printf '%s\n' "${HIVE_FAKE_CODEX_LOGIN_STATUS:-Logged in}"
+  exit "${HIVE_FAKE_CODEX_LOGIN_EXIT:-0}"
+fi
+
+if [[ "${1:-}" == "exec" ]]; then
+  if [[ -n "${HIVE_FAKE_CODEX_ARGV_LOG:-}" ]]; then
+    mkdir -p "$(dirname "${HIVE_FAKE_CODEX_ARGV_LOG}")"
+    {
+      echo "---"
+      echo "cwd=$(pwd)"
+      for a in "$@"; do
+        printf 'arg=%s\n' "$a"
+      done
+    } >> "${HIVE_FAKE_CODEX_ARGV_LOG}"
+  fi
+  if [[ -n "${HIVE_FAKE_CODEX_HANG:-}" ]]; then
+    sleep "${HIVE_FAKE_CODEX_HANG}"
+  fi
+  printf '%s\n' "${HIVE_FAKE_CODEX_EXEC_OUTPUT:-OK}"
+  exit "${HIVE_FAKE_CODEX_EXEC_EXIT:-0}"
+fi
+
 if [[ "${1:-}" == "review" ]]; then
   if [[ -n "${HIVE_FAKE_CODEX_ARGV_LOG:-}" ]]; then
     mkdir -p "$(dirname "${HIVE_FAKE_CODEX_ARGV_LOG}")"
diff --git a/test/integration/daemon_recoverable_marker_retry_test.rb b/test/integration/daemon_recoverable_marker_retry_test.rb
new file mode 100644
index 00000000..f2541deb
--- /dev/null
+++ b/test/integration/daemon_recoverable_marker_retry_test.rb
@@ -0,0 +1,121 @@
+require "test_helper"
+require "hive/commands/init"
+require "hive/commands/new"
+require "hive/daemon/auto_retry_health"
+require "hive/daemon/recoverable_marker_retry"
+require "hive/daemon/dispatch_request_queue"
+require "hive/daemon/dispatcher"
+require "hive/daemon/logger"
+require "hive/marker_recovery"
+require "hive/task"
+
+class DaemonRecoverableMarkerRetryTest < Minitest::Test
+  include HiveTestHelper
+
+  Row = Struct.new(:project, :slug, :task_id, :stage, :marker, :marker_attrs, :folder,
+                   :state_file, :worktree_path, :live_task_lock, keyword_init: true)
+
+  class Logger
+    attr_reader :events
+    def initialize = @events = []
+    def event(name, **attrs) = @events << [ name, attrs ]
+  end
+
+  def test_closed_claude_failure_stages_queue_then_clear_and_audit_a_normal_plan_rerun
+    with_task do |dir, row|
+      health = healthy_bundle("recovered")
+      policy = policy_for(row, health)
+      decision = policy.decide(row)
+      assert decision.approved?
+
+      request_id = Hive::Daemon::DispatchRequestQueue.write_request!(
+        project: row.project, slug: row.slug,
+        argv: [ "hive", "plan", row.slug, "--project", row.project, "--from", "3-plan" ],
+        requestor: "healer", trigger: "dependency_health_recovery",
+        recovery: { task_id: row.task_id, stage: row.stage, marker_id: row.marker_attrs.fetch("marker_id"),
+                    reason: "claude_launch_failed", attempt: 1 }
+      )
+      task = Hive::Task.new(row.folder)
+      assert Hive::MarkerRecovery.new.clear!(
+        task: task, expected_name: :error,
+        match_attrs: { "marker_id" => row.marker_attrs.fetch("marker_id"), "reason" => "claude_launch_failed" },
+        action: "auto retry claude_launch_failed", details: decision.audit
+      )
+      assert policy.record_recovery(row, decision)
+
+      assert_equal :none, Hive::Markers.current(row.state_file).name
+      request = Hive::Daemon::DispatchRequestQueue.pending.find { |entry| entry.request_id == request_id }
+      refute_nil request
+      assert_equal [ "hive", "plan", row.slug, "--project", row.project, "--from", "3-plan" ], request.argv
+      assert_equal "claude_launch_failed", request.recovery.fetch("reason")
+      dispatcher = Hive::Daemon::Dispatcher.allocate
+      assert dispatcher.send(:recovery_request_valid?, request), "markerless recovered state permits delayed dispatch"
+      Hive::Markers.set(row.state_file, :error, reason: "manual_intervention")
+      refute dispatcher.send(:recovery_request_valid?, request), "any replacement marker invalidates recovery request"
+      event_types = File.readlines(File.join(row.folder, "events.jsonl"), chomp: true).map { |line| JSON.parse(line)["event_type"] }
+      assert_includes event_types, "auto_retry_failure_observed"
+      assert_includes event_types, "auto_retry_decision"
+      assert_includes event_types, "marker_recovery"
+    end
+  end
+
+  def test_unknown_marker_never_probes_or_clears
+    with_task(reason: "business_failure", exception_class: nil, message: "exit_code=1") do |_dir, row|
+      health = Object.new
+      health.define_singleton_method(:bundle_for) { |_row, _candidate| flunk "unknown marker must not probe" }
+      classifier = Hive::Daemon::RecoverableFailure.new
+      policy = Hive::Daemon::RecoverableMarkerRetry.new(classifier: classifier, health: health, logger: Logger.new)
+      decision = policy.decide(row)
+
+      assert_equal "unsupported_reason", decision.code
+      assert_equal :error, Hive::Markers.current(row.state_file).name
+    end
+  end
+
+  private
+
+  def with_task(reason: "claude_launch_failed", exception_class: "Hive::AgentError",
+                message: "claude interactive prompt did not become ready in tmux session hive-plan-task")
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        capture_io { Hive::Commands::Init.new(dir).call }
+        project = File.basename(dir)
+        capture_io { Hive::Commands::New.new(project, "recovery integration").call }
+        inbox = Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "*")].first
+        folder = File.join(dir, ".hive-state", "stages", "3-plan", File.basename(inbox))
+        FileUtils.mkdir_p(File.dirname(folder))
+        FileUtils.mv(inbox, folder)
+        state_file = File.join(folder, "plan.md")
+        attrs = { reason: reason, message: message }
+        attrs[:exception_class] = exception_class if exception_class
+        Hive::Markers.set(state_file, :error, attrs)
+        marker = Hive::Markers.current(state_file)
+        row = Row.new(project: project, slug: File.basename(folder), task_id: Hive::Task.new(folder).id,
+                      stage: "3-plan", marker: "error", marker_attrs: marker.attrs, folder: folder,
+                      state_file: state_file, worktree_path: nil, live_task_lock: false)
+        yield dir, row
+      end
+    end
+  end
+
+  def healthy_bundle(fingerprint)
+    probe = Hive::Daemon::AutoRetryHealth::Probe.new(name: "all", healthy: true, exit_status: 0,
+                                                      timed_out: false, duration_ms: 1, stdout: "", stderr: "", fingerprint: "p")
+    Hive::Daemon::AutoRetryHealth::Bundle.new(healthy: true, reason: "claude_launch_failed", probes: [ probe ],
+                                               cheap_fingerprint: "cheap", fingerprint: fingerprint)
+  end
+
+  def policy_for(row, bundle)
+    classifier = Object.new
+    classifier.define_singleton_method(:classify) do |current|
+      Hive::Daemon::RecoverableFailure::Candidate.new(
+        marker_id: current.marker_attrs.fetch("marker_id"), reason: current.marker_attrs.fetch("reason"), stage: current.stage,
+        diagnostic_kind: "claude_launch", evidence_source: "marker", task_id: current.task_id,
+        task_folder: current.folder, worktree_path: nil, evidence: current.marker_attrs.fetch("message")
+      )
+    end
+    health = Object.new
+    health.define_singleton_method(:bundle_for) { |_current, _candidate| bundle }
+    Hive::Daemon::RecoverableMarkerRetry.new(classifier: classifier, health: health, logger: Logger.new)
+  end
+end
diff --git a/test/unit/config_test.rb b/test/unit/config_test.rb
index f9b9a92d..6f3ea7d0 100644
--- a/test/unit/config_test.rb
+++ b/test/unit/config_test.rb
@@ -3011,6 +3011,19 @@ class ConfigTest < Minitest::Test
     end
   end
 
+  def test_global_daemon_auto_retry_defaults_to_enabled_and_validates_boolean
+    with_tmp_global_config do |home|
+      cfg = Hive::Config.load_global_daemon
+      assert_equal true, cfg.dig("auto_retry", "enabled")
+
+      File.write(File.join(home, "config.yml"), {
+        "registered_projects" => [], "daemon" => { "auto_retry" => { "enabled" => "yes" } }
+      }.to_yaml)
+      error = assert_raises(Hive::ConfigError) { Hive::Config.load_global_daemon }
+      assert_match(/daemon\.auto_retry\.enabled.*must be a boolean/, error.message)
+    end
+  end
+
   def test_load_global_daemon_honors_global_config_overrides
     with_tmp_global_config do |home|
       File.write(File.join(home, "config.yml"), <<~YAML)
diff --git a/test/unit/daemon/auto_retry_health_test.rb b/test/unit/daemon/auto_retry_health_test.rb
new file mode 100644
index 00000000..3c2e45a4
--- /dev/null
+++ b/test/unit/daemon/auto_retry_health_test.rb
@@ -0,0 +1,92 @@
+require "test_helper"
+require "hive/daemon/auto_retry_health"
+
+class HiveDaemonAutoRetryHealthTest < Minitest::Test
+  include HiveTestHelper
+
+  Row = Struct.new(:project, :slug, :stage, :folder, keyword_init: true)
+  Candidate = Struct.new(:reason, keyword_init: true)
+
+  def test_codex_bundle_requires_logged_in_status_and_a_read_only_smoke
+    with_tmp_dir do |dir|
+      argv_log = File.join(dir, "codex-argv.log")
+      env = {
+        "PATH" => ENV.fetch("PATH"), "HOME" => dir,
+        "HIVE_CODEX_BIN" => File.expand_path("../../fixtures/fake-codex", __dir__),
+        "HIVE_FAKE_CODEX_ARGV_LOG" => argv_log
+      }
+      health = subject(env: env, project_root: dir, command_env: { "HIVE_FAKE_CODEX_ARGV_LOG" => argv_log })
+      bundle = health.bundle_for(Row.new(project: "p", slug: "task", stage: "4-execute", folder: dir),
+                                 Candidate.new(reason: "implementer_failed"))
+
+      assert bundle.healthy
+      log = File.read(argv_log)
+      assert_includes log, "arg=--sandbox"
+      assert_includes log, "arg=read-only"
+      assert_includes log, "arg=--ask-for-approval"
+      assert_includes log, "arg=never"
+      refute_includes log, "dangerously-bypass"
+      refute_equal dir, log[/cwd=(.+)/, 1], "smoke must never run from a task/project cwd"
+    end
+  end
+
+  def test_failed_login_or_smoke_keeps_bundle_unhealthy
+    with_tmp_dir do |dir|
+      base = {
+        "PATH" => ENV.fetch("PATH"), "HOME" => dir,
+        "HIVE_CODEX_BIN" => File.expand_path("../../fixtures/fake-codex", __dir__)
+      }
+      [ { "HIVE_FAKE_CODEX_LOGIN_STATUS" => "not authenticated" }, { "HIVE_FAKE_CODEX_EXEC_EXIT" => "1" } ].each do |override|
+        bundle = subject(env: base, project_root: dir, command_env: override).bundle_for(
+          Row.new(project: "p", slug: "task", stage: "4-execute", folder: dir), Candidate.new(reason: "implementer_failed")
+        )
+        refute bundle.healthy
+      end
+    end
+  end
+
+  def test_command_output_is_capped_and_redacted
+    with_tmp_dir do |dir|
+      script = File.join(dir, "secret")
+      File.write(script, "#!/bin/sh\nprintf 'Authorization: Bearer sk-123456789012345678901234567890\\n'\n")
+      File.chmod(0o755, script)
+      probe = subject(env: { "PATH" => ENV.fetch("PATH"), "HOME" => dir }, project_root: dir).send(
+        :run_command, name: "secret", argv: [ script ], timeout_sec: 1
+      )
+      assert probe.healthy
+      assert_includes probe.stdout, "[REDACTED:bearer_token]"
+      refute_includes probe.stdout, "sk-123456789012345678901234567890"
+    end
+  end
+
+  def test_timeout_is_an_unhealthy_stable_result
+    with_tmp_dir do |dir|
+      script = File.join(dir, "hang")
+      File.write(script, "#!/bin/sh\nsleep 2\n")
+      File.chmod(0o755, script)
+      probe = subject(env: { "PATH" => ENV.fetch("PATH"), "HOME" => dir }, project_root: dir).send(
+        :run_command, name: "hang", argv: [ script ], timeout_sec: 0.05
+      )
+      refute probe.healthy
+      assert probe.timed_out
+      refute_empty probe.fingerprint
+    end
+  end
+
+  def test_ready_detector_self_check_is_true
+    assert Hive::ClaudeLauncher.ready_detector_self_check
+  end
+
+  private
+
+  def subject(env:, project_root:, command_env: {})
+    Hive::Daemon::AutoRetryHealth.new(
+      env: env,
+      project_root_resolver: ->(_row) { project_root },
+      config_loader: ->(_root) { { "execute" => { "agent" => "codex" }, "claude" => { "mode" => "tmux" } } },
+      universal_checker: ->(_cfg, _root) { [ { label: "skills", status: "present" } ] },
+      invoked_binary: Object.new.tap { |obj| obj.define_singleton_method(:path) { |env:| nil } },
+      command_env: command_env
+    )
+  end
+end
diff --git a/test/unit/daemon/dispatch_request_queue_test.rb b/test/unit/daemon/dispatch_request_queue_test.rb
index a3c6f5e7..ee869dcb 100644
--- a/test/unit/daemon/dispatch_request_queue_test.rb
+++ b/test/unit/daemon/dispatch_request_queue_test.rb
@@ -55,6 +55,40 @@ class HiveDaemonDispatchRequestQueueTest < Minitest::Test
     end
   end
 
+  def test_recovery_identity_round_trips_and_disables_generic_expiry
+    Dir.mktmpdir("hive-dispatch-queue") do |dir|
+      request_id = Q.write_request!(
+        project: "hive", slug: "task-260724-a1b2",
+        argv: [ "hive", "run", "task-260724-a1b2", "--stage", "4-execute" ],
+        requestor: "healer", trigger: "dependency_health_recovery",
+        recovery: {
+          task_id: 58, stage: "4-execute", marker_id: "marker-58",
+          reason: "implementer_failed", attempt: 1
+        },
+        state_home: dir, now: Time.utc(2026, 7, 24)
+      )
+
+      request = Q.pending(state_home: dir).find { |entry| entry.request_id == request_id }
+      assert_equal "4-execute", request.recovery.fetch("stage")
+      assert_equal 58, request.recovery.fetch("task_id")
+      refute Q.expired?(request, now: Time.utc(2026, 7, 25)),
+             "validated recovery identity owns expiry through dispatcher state validation"
+    end
+  end
+
+  def test_recovery_identity_rejects_extra_or_incomplete_keys
+    Dir.mktmpdir("hive-dispatch-queue") do |dir|
+      assert_raises(ArgumentError) do
+        Q.write_request!(
+          project: "hive", slug: "task-260724-a1b2", argv: [ "hive", "run", "task-260724-a1b2" ],
+          recovery: { task_id: 58, stage: "4-execute", marker_id: "m", reason: "implementer_failed", attempt: 1,
+                      extra: "not allowed" },
+          state_home: dir
+        )
+      end
+    end
+  end
+
   def test_pending_skips_malformed_json_via_bad_handler
     Dir.mktmpdir("hive-dispatch-queue") do |dir|
       good = write_request(dir, request_id: "OK", created_at: Time.utc(2026, 5, 28, 18, 0, 0), slug: "good")
diff --git a/test/unit/daemon/recoverable_failure_test.rb b/test/unit/daemon/recoverable_failure_test.rb
new file mode 100644
index 00000000..03c58662
--- /dev/null
+++ b/test/unit/daemon/recoverable_failure_test.rb
@@ -0,0 +1,106 @@
+require "test_helper"
+require "hive/daemon/recoverable_failure"
+
+class HiveDaemonRecoverableFailureTest < Minitest::Test
+  include HiveTestHelper
+  Row = Struct.new(:project, :slug, :task_id, :stage, :marker, :marker_attrs,
+                   :folder, :state_file, :state_file_mtime, :worktree_path,
+                   keyword_init: true)
+
+  def row(stage: "4-execute", reason: "implementer_failed", provider: "codex", message: nil, **extra)
+    attrs = {
+      "reason" => reason, "provider" => provider, "marker_id" => "marker-1",
+      "message" => message
+    }.merge(extra.delete(:attrs) || {})
+    Row.new(
+      project: "project", slug: "task-58", task_id: 58, stage: stage,
+      marker: "error", marker_attrs: attrs, folder: extra[:folder] || "/tmp/no-task",
+      state_file: extra[:state_file] || "/tmp/no-task/task.md",
+      state_file_mtime: extra[:state_file_mtime], worktree_path: extra[:worktree_path]
+    )
+  end
+
+  def test_classifies_structured_codex_http_401_missing_bearer_marker
+    result = subject.classify(row(
+      message: "HTTP 401: missing bearer token",
+      attrs: { "diagnostic" => "codex_auth_401" }
+    ))
+
+    assert_instance_of Hive::Daemon::RecoverableFailure::Candidate, result
+    assert_equal "codex_auth_401", result.diagnostic_kind
+    assert_equal "marker", result.evidence_source
+    assert_equal 58, result.task_id
+  end
+
+  def test_refuses_codex_near_misses
+    [
+      row(message: "HTTP 401 unauthorized"),
+      row(message: "missing bearer token"),
+      row(provider: "claude", message: "HTTP 401 missing bearer token"),
+      row(stage: "3-plan", message: "HTTP 401 missing bearer token"),
+      row(reason: "implementer_failed", message: "HTTP 401 missing bearer token", attrs: {})
+    ].each do |candidate_row|
+      result = subject.classify(candidate_row)
+      assert_instance_of Hive::Daemon::RecoverableFailure::Refusal, result
+    end
+  end
+
+  def test_classifies_only_closed_claude_launcher_messages
+    result = subject.classify(row(
+      stage: "3-plan", reason: "claude_launch_failed", provider: nil,
+      message: "claude interactive prompt did not become ready in tmux session hive-plan-task",
+      attrs: { "exception_class" => "Hive::AgentError" }
+    ))
+
+    assert_instance_of Hive::Daemon::RecoverableFailure::Candidate, result
+    assert_equal "claude_launch", result.diagnostic_kind
+
+    unknown = subject.classify(row(
+      reason: "claude_launch_failed", provider: nil,
+      message: "some arbitrary Hive::AgentError", attrs: { "exception_class" => "Hive::AgentError" }
+    ))
+    assert_equal "claude_launch_signature_missing", unknown.code
+  end
+
+  def test_classifies_a_bounded_correlated_legacy_execute_log
+    with_tmp_dir do |dir|
+      folder = File.join(dir, ".hive-state", "stages", "4-execute", "task-58")
+      log_dir = File.join(dir, ".hive-state", "logs", "task-58")
+      FileUtils.mkdir_p(folder)
+      FileUtils.mkdir_p(log_dir)
+      state_file = File.join(folder, "task.md")
+      File.write(state_file, "<!-- ERROR reason=implementer_failed provider=codex marker_id=marker-1 -->\n")
+      log = File.join(log_dir, "execute-impl-20260724.log")
+      File.write(log, "request failed: HTTP 401 missing basic authentication\n")
+
+      result = subject.classify(row(folder: folder, state_file: state_file,
+                                    state_file_mtime: File.mtime(state_file), message: "exit_code=1"))
+
+      assert_instance_of Hive::Daemon::RecoverableFailure::Candidate, result
+      assert_equal "execute_impl_log", result.evidence_source
+    end
+  end
+
+  def test_refuses_ambiguous_or_symlinked_legacy_logs
+    with_tmp_dir do |dir|
+      folder = File.join(dir, ".hive-state", "stages", "4-execute", "task-58")
+      logs = File.join(dir, ".hive-state", "logs", "task-58")
+      FileUtils.mkdir_p(folder)
+      FileUtils.mkdir_p(logs)
+      state_file = File.join(folder, "task.md")
+      File.write(state_file, "<!-- ERROR reason=implementer_failed provider=codex marker_id=marker-1 -->\n")
+      2.times do |index|
+        File.write(File.join(logs, "execute-impl-#{index}.log"), "HTTP 401 missing bearer token")
+      end
+
+      result = subject.classify(row(folder: folder, state_file: state_file, message: "exit_code=1"))
+      assert_equal "codex_auth_signature_missing", result.code
+    end
+  end
+
+  private
+
+  def subject
+    @subject ||= Hive::Daemon::RecoverableFailure.new
+  end
+end
